//+------------------------------------------------------------------+
//|                                               MultiSymbolATR.mq5 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property indicator_separate_window //    
#property indicator_minimum 0       //   
#property indicator_buffers 6       //     
#property indicator_plots   6       //   
//---  
#define RESET           0 //      
#define LEVELS_COUNT    6 //  
#define SYMBOLS_COUNT   6 //  
//---      
#include <Canvas\Canvas.mqh>

//---  
input  int              IndicatorPeriod=14;       //  
sinput string dlm01=""; //- - - - - - - - - - - - - - - - - - - - - - - - - - -
input  string           Symbol02       ="GBPUSD"; //  2
input  string           Symbol03       ="AUDUSD"; //  3
input  string           Symbol04       ="NZDUSD"; //  4
input  string           Symbol05       ="USDCAD"; //  5
input  string           Symbol06       ="USDCHF"; //  6
sinput string dlm02=""; //- - - - - - - - - - - - - - - - - - - - - - - - - - -
input  int              Level01        =10;       //  1
input  int              Level02        =50;       //  2
input  int              Level03        =100;      //  3
input  int              Level04        =200;      //  4
input  int              Level05        =400;      //  5
input  int              Level06        =600;      //  6

//---    
CCanvas           canvas;                 //  
//--- /     OnCalculate()
int               OC_rates_total     =0;  //   
int               OC_prev_calculated =0;  //     
datetime          OC_time[];              //  
double            OC_open[];              //  
double            OC_high[];              //  
double            OC_low[];               //  
double            OC_close[];             //  
long              OC_tick_volume[];       //  
long              OC_volume[];            //  
int               OC_spread[];            // 
//---      
struct buffers {double data[];};
buffers           atr_buffers[SYMBOLS_COUNT];
//---      
struct temp_time {datetime time[];};
temp_time         tmp_symbol_time[SYMBOLS_COUNT];
//---     ATR   
struct temp_atr {double value[];};
temp_atr          tmp_atr_values[SYMBOLS_COUNT];
//---         
datetime          series_first_date[SYMBOLS_COUNT];
datetime          series_first_date_last[SYMBOLS_COUNT];
//---  ,    
datetime          limit_time[SYMBOLS_COUNT];
//---  
int               indicator_levels[LEVELS_COUNT];
//---  
string            symbol_names[SYMBOLS_COUNT];
//---  
int               symbol_handles[SYMBOLS_COUNT];
//---   
color             line_colors[SYMBOLS_COUNT]={clrRed,clrDodgerBlue,clrLimeGreen,clrGold,clrAqua,clrMagenta};
//--- ,   
string            empty_symbol="EMPTY";
//---   
int               subwindow_number        =WRONG_VALUE;              //  
int               chart_width             =0;                        //  
int               subwindow_height        =0;                        //  
int               last_chart_width        =0;                        //     
int               last_subwindow_height   =0;                        //     
int               subwindow_center_x      =0;                        //    
int               subwindow_center_y      =0;                        //    
string            subwindow_shortname     ="MS_ATR";                 //   
string            prefix                  =subwindow_shortname+"_";  //   
//---  
string            canvas_name             =prefix+"canvas";          //  
color             canvas_background       =clrBlack;                 //   
uchar             canvas_opacity          =190;                      //  
int               font_size               =16;                       //  
string            font_name               ="Calibri";                // 
ENUM_COLOR_FORMAT clr_format              =COLOR_FORMAT_ARGB_RAW;    //       
//---  
string            msg_invalid_handle      ="  ! , ...";
string            msg_prepare_data        =" ! , ...";
string            msg_not_synchronized    ="  ! , ...";
string            msg_load_data           ="";
string            msg_sync_update         ="";
string            msg_last                ="";
//---   ,    
int               terminal_max_bars=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---    
   if(!CheckInputParameters())
      return(INIT_PARAMETERS_INCORRECT);
//---     1 
   EventSetTimer(1);
//---      
   canvas.FontSet(font_name,font_size,FW_NORMAL);
//---  
   InitArrays();
//---    
   InitSymbolNames();
//---   
   InitLevels();
//---   
   GetIndicatorHandles();
//---   
   SetIndicatorProperties();
//---   ,    
   terminal_max_bars=TerminalInfoInteger(TERMINAL_MAXBARS);
//---  
   Comment("");
//---  
   ChartRedraw();
//---   
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   if(reason==REASON_REMOVE      || //      
      reason==REASON_CHARTCHANGE || //      
      reason==REASON_RECOMPILE   || //    
      reason==REASON_CHARTCLOSE  || //    
      reason==REASON_CLOSE       || //    
      reason==REASON_PARAMETERS)    //   
     {
      //---  
      EventKillTimer();
      //---  
      DeleteLevels();
      //---   
      DeleteVerticalLines();
      //---  
      DeleteCanvas();
      //---    
      for(int s=0; s<SYMBOLS_COUNT; s++)
         IndicatorRelease(symbol_handles[s]);
      //---  
      Comment("");
     }
//---  
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int      rates_total,     //   
                const int      prev_calculated, //     
                const datetime &time[],         //  
                const double   &open[],         //  
                const double   &high[],         //  
                const double   &low[],          //  
                const double   &close[],        //  
                const long     &tick_volume[],  //  
                const long     &volume[],       //  
                const int      &spread[])       // 
  {
//---   ,     
   int limit=0;
//---    OnCalculate()
   CopyDataOnCalculate(rates_total,prev_calculated,
                       time,open,high,low,close,
                       tick_volume,volume,spread);
//---      
   ResizeCalculatedArrays();
//---              
   if(prev_calculated==0)
     {
      //---     
      ZeroCalculatedArrays();
      //---   
      ZeroIndicatorBuffers();
      //---   
      GetSubwindowGeometry();
      //---  
      SetCanvas();
      //---    /  
      LoadAndFormData();
      //---    ,    
      if(!GetIndicatorHandles())
         return(RESET);
      //---       
      if(!CheckAvailableData())
         return(RESET);
      //--- ,     
      if(!CheckLoadedHistory())
         return(RESET);
      //---     /   
      if(!CheckSymbolIsSynchronized())
         return(RESET);
      //---    ,     
      if(!DetermineFirstTrueBar())
         return(RESET);
      //---     ,   OnCalculate()       
      OC_prev_calculated=rates_total;
     }
//---      
   else
      limit=prev_calculated-1;

//---    
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      //---   
      if(symbol_names[s]!=empty_symbol)
        {
         double percent=0.0; //    
         msg_last=msg_sync_update="  ("+IntegerToString(rates_total)+" ) : "+
                  symbol_names[s]+"("+(string)(s+1)+"/"+(string)(SYMBOLS_COUNT)+") - 00% ... ";
         //---  
         ShowCanvasMessage(msg_sync_update);
         //---    
         for(int i=limit; i<rates_total; i++)
           {
            PrepareData(i,s,time);
            //---  1000   
            if(i%1000==0)
              {
               //---  
               ProgressPercentage(i,s,percent);
               //---  
               ShowCanvasMessage(msg_sync_update);
              }
            //---  2000    
            //    ,   ,     
            if(i%2000==0)
               OnSubwindowChange();
           }
        }
     }
//---   
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      //---     ,  
      if(symbol_names[s]==empty_symbol)
         ArrayInitialize(atr_buffers[s].data,EMPTY_VALUE);
      else
        {
         //---  
         msg_last=msg_sync_update="  : "+
                  symbol_names[s]+"("+(string)(s+1)+"/"+(string)SYMBOLS_COUNT+") ... ";
         //---  
         ShowCanvasMessage(msg_sync_update);
         //---    
         for(int i=limit; i<rates_total; i++)
           {
            FillIndicatorBuffers(i,s,time);
            //---  2000    
            //    ,   ,     
            if(i%2000==0)
               OnSubwindowChange();
           }
        }
     }
//---  
   DeleteCanvas();
//---   
   SetIndicatorLevels();
//---  
   msg_last="";
   msg_sync_update="";
//---  
   ChartRedraw();
//---      
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---      
   if(!CheckLoadedHistory())
      OC_prev_calculated=0;
//---   -      
//        
//       , 
//    ,   ,    
   if(OC_prev_calculated==0)
     {
      OnCalculate(OC_rates_total,OC_prev_calculated,
                  OC_time,OC_open,OC_high,OC_low,OC_close,
                  OC_tick_volume,OC_volume,OC_spread);
     }
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
bool CheckInputParameters()
  {
   if(IndicatorPeriod>500)
     {
      Comment("  ! Indicator Period: ",IndicatorPeriod,"; Limit: 500;");
      printf("  ! Indicator Period: %d; Limit: %d;",IndicatorPeriod,500);
      return(false);
     }
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void InitArrays()
  {
   ArrayInitialize(limit_time,NULL);
   ArrayInitialize(series_first_date,NULL);
   ArrayInitialize(series_first_date_last,NULL);
   ArrayInitialize(symbol_handles,INVALID_HANDLE);
//---
   for(int s=0; s<SYMBOLS_COUNT; s++)
      ArrayInitialize(atr_buffers[s].data,EMPTY_VALUE);
  }
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
void InitSymbolNames()
  {
   symbol_names[0]=AddSymbolToMarketWatch(_Symbol);
   symbol_names[1]=AddSymbolToMarketWatch(Symbol02);
   symbol_names[2]=AddSymbolToMarketWatch(Symbol03);
   symbol_names[3]=AddSymbolToMarketWatch(Symbol04);
   symbol_names[4]=AddSymbolToMarketWatch(Symbol05);
   symbol_names[5]=AddSymbolToMarketWatch(Symbol06);
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void InitLevels()
  {
   indicator_levels[0]=Level01;
   indicator_levels[1]=Level02;
   indicator_levels[2]=Level03;
   indicator_levels[3]=Level04;
   indicator_levels[4]=Level05;
   indicator_levels[5]=Level06;
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
string AddSymbolToMarketWatch(string symbol)
  {
   int      total=0; //  
   string   name=""; //  
//---    ,   
   if(symbol=="")
      return(empty_symbol);
//---    
   total=SymbolsTotal(false);
//---     
   for(int i=0;i<total;i++)
     {
      //---    
      name=SymbolName(i,false);
      //---    , 
      if(name==symbol)
        {
         //---       
         SymbolSelect(name,true);
         //---   
         return(name);
        }
     }
//---    ,  ,   
   return(empty_symbol);
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
bool GetIndicatorHandles()
  {
//---  ,    
   bool valid_handles=true;
//---        ...
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      //---   
      if(symbol_names[s]!=empty_symbol)
        {
         //      
         if(symbol_handles[s]==INVALID_HANDLE)
           {
            //---  
            symbol_handles[s]=iATR(symbol_names[s],Period(),IndicatorPeriod);
            //---     ,    
            if(symbol_handles[s]==INVALID_HANDLE)
               valid_handles=false;
           }
        }
     }
//---  ,        
   if(!valid_handles)
     {
      msg_last=msg_invalid_handle;
      ShowCanvasMessage(msg_invalid_handle);
     }
//---
   return(valid_handles);
  }
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
void SetIndicatorProperties()
  {
//---   
   IndicatorSetString(INDICATOR_SHORTNAME,subwindow_shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//---    
   for(int s=0; s<SYMBOLS_COUNT; s++)
      SetIndexBuffer(s,atr_buffers[s].data,INDICATOR_DATA);
//---     
   for(int s=0; s<SYMBOLS_COUNT; s++)
      PlotIndexSetString(s,PLOT_LABEL,"ATR ("+IntegerToString(s)+", "+symbol_names[s]+")");
//---    : 
   for(int s=0; s<SYMBOLS_COUNT; s++)
      PlotIndexSetInteger(s,PLOT_DRAW_TYPE,DRAW_LINE);
//---   
   for(int s=0; s<SYMBOLS_COUNT; s++)
      PlotIndexSetInteger(s,PLOT_LINE_WIDTH,1);
//---   
   for(int s=0; s<SYMBOLS_COUNT; s++)
      PlotIndexSetInteger(s,PLOT_LINE_COLOR,line_colors[s]);
//---    ,    
   for(int s=0; s<SYMBOLS_COUNT; s++)
      PlotIndexSetDouble(s,PLOT_EMPTY_VALUE,EMPTY_VALUE);
  }
//+------------------------------------------------------------------+
//|    OnCalculate                                   |
//+------------------------------------------------------------------+
void CopyDataOnCalculate(const int      rates_total,
                         const int      prev_calculated,
                         const datetime &time[],
                         const double   &open[],
                         const double   &high[],
                         const double   &low[],
                         const double   &close[],
                         const long     &tick_volume[],
                         const long     &volume[],
                         const int      &spread[])
  {
   OC_rates_total=rates_total;
   OC_prev_calculated=prev_calculated;
   ArrayCopy(OC_time,time);
   ArrayCopy(OC_open,open);
   ArrayCopy(OC_high,high);
   ArrayCopy(OC_low,low);
   ArrayCopy(OC_close,close);
   ArrayCopy(OC_tick_volume,tick_volume);
   ArrayCopy(OC_volume,volume);
   ArrayCopy(OC_spread,spread);
  }
//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+
void ResizeCalculatedArrays()
  {
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      ArrayResize(tmp_symbol_time[s].time,OC_rates_total);
      ArrayResize(tmp_atr_values[s].value,OC_rates_total);
     }
  }
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
void ZeroCalculatedArrays()
  {
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      ArrayInitialize(tmp_symbol_time[s].time,NULL);
      ArrayInitialize(tmp_atr_values[s].value,EMPTY_VALUE);
     }
  }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void ZeroIndicatorBuffers()
  {
   for(int s=0; s<SYMBOLS_COUNT; s++)
      ArrayInitialize(atr_buffers[s].data,EMPTY_VALUE);
  }
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
void GetSubwindowGeometry()
  {
//---    
   subwindow_number=ChartWindowFind(0,subwindow_shortname);
//---     
   chart_width=(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS);
   subwindow_height=(int)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,subwindow_number);
//---   
   subwindow_center_x=chart_width/2;
   subwindow_center_y=subwindow_height/2;
  }
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
void SetCanvas()
  {
//---   ,  
   if(ObjectFind(0,canvas_name)<0)
     {
      //---  
      canvas.CreateBitmapLabel(0,subwindow_number,canvas_name,0,0,chart_width,subwindow_height,clr_format);
      //---    
      canvas.Erase(ColorToARGB(canvas_background,0));
      //---  
      canvas.Update();
     }
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void OnSubwindowChange()
  {
//---   
   GetSubwindowGeometry();
//---     , 
   if(!SubwindowSizeChanged())
      return;
//---     1     , 
   if(subwindow_height<1 || subwindow_center_y<1)
      return;
//---    
   ResizeCanvas();
//---   
   ShowCanvasMessage(msg_last);
  }
//+------------------------------------------------------------------+
//| ,                             |
//+------------------------------------------------------------------+
bool SubwindowSizeChanged()
  {
//---     , 
   if(last_chart_width==chart_width && last_subwindow_height==subwindow_height)
      return(false);
//---   ,   
   else
     {
      last_chart_width=chart_width;
      last_subwindow_height=subwindow_height;
     }
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
void ResizeCanvas()
  {
//---       ,   
   if(ObjectFind(0,canvas_name)==subwindow_number)
      canvas.Resize(chart_width,subwindow_height);
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void ShowCanvasMessage(string message_text)
  {
   GetSubwindowGeometry();
//---       
   if(ObjectFind(0,canvas_name)==subwindow_number)
     {
      //---        ,  
      if(message_text!="" && subwindow_center_x>0 && subwindow_center_y>0)
        {
         canvas.Erase(ColorToARGB(canvas_background,canvas_opacity));
         canvas.TextOut(subwindow_center_x,subwindow_center_y,message_text,ColorToARGB(clrRed),TA_CENTER|TA_VCENTER);
         canvas.Update();
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                      |
//+------------------------------------------------------------------+
void DeleteCanvas()
  {
//---  ,   
   if(ObjectFind(0,canvas_name)>0)
     {
      //---     
      for(int i=canvas_opacity; i>0; i-=5)
        {
         canvas.Erase(ColorToARGB(canvas_background,(uchar)i));
         canvas.Update();
        }
      //---   
      canvas.Destroy();
     }
  }
//+------------------------------------------------------------------+
//|    / -         |
//+------------------------------------------------------------------+
void LoadAndFormData()
  {
   int bars_count=100; //   
//---
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      int      attempts          =0;    //    
      int      array_size        =0;    //  
      datetime firstdate_server  =NULL; //     
      datetime firstdate_terminal=NULL; //      
      //---     /   
      SeriesInfoInteger(symbol_names[s],Period(),SERIES_FIRSTDATE,firstdate_terminal);
      //---    -  
      SeriesInfoInteger(symbol_names[s],Period(),SERIES_SERVER_FIRSTDATE,firstdate_server);
      //---  
      msg_last=msg_load_data="    : "+
               symbol_names[s]+"("+(string)(s+1)+"/"+(string)SYMBOLS_COUNT+") ... ";
      ShowCanvasMessage(msg_load_data);
      //--- / .
      //       ,      ,   
      //                   
      while(array_size<OC_rates_total && 
            firstdate_terminal-firstdate_server>PeriodSeconds()*bars_count)
        {
         datetime copied_time[];
         //---     /   
         SeriesInfoInteger(symbol_names[s],Period(),SERIES_FIRSTDATE,firstdate_terminal);
         //--- /    
         if(CopyTime(symbol_names[s],Period(),0,array_size+bars_count,copied_time)!=-1)
           {
            //---         -   , 
            //         ,  
            if(copied_time[0]-PeriodSeconds()*bars_count<OC_time[0])
               break;
            //---     ,  
            if(ArraySize(copied_time)==array_size)
               attempts++;
            //---     
            else
               array_size=ArraySize(copied_time);
            //---        100 ,  
            if(attempts==100)
              {
               attempts=0;
               break;
              }
           }
         //---  2000     
         //    ,   ,     
         if(!(array_size%2000))
            OnSubwindowChange();
        }
     }
  }
//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+
bool CheckAvailableData()
  {
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      //---    
      if(symbol_names[s]!=empty_symbol)
        {
         double   data[]; //      
         datetime time[]; //     
         int      calculated_values =0;    //   
         int      available_bars    =0;    //    
         datetime firstdate_terminal=NULL; //        
         //---  -   
         calculated_values=BarsCalculated(symbol_handles[s]);
         //---        
         firstdate_terminal=(datetime)SeriesInfoInteger(symbol_names[s],Period(),SERIES_TERMINAL_FIRSTDATE);
         //---       
         available_bars=Bars(symbol_names[s],Period(),firstdate_terminal,TimeCurrent());
         //---    :  5   
         for(int i=0; i<5; i++)
           {
            //---    
            if(CopyTime(symbol_names[s],Period(),0,available_bars,time)!=-1)
              {
               //---    ,  
               if(ArraySize(time)>=available_bars)
                  break;
              }
           }
         //---    :  5   
         for(int i=0; i<5; i++)
           {
            //---    
            if(CopyBuffer(symbol_handles[s],0,0,calculated_values,data)!=-1)
              {
               //---    ,  
               if(ArraySize(data)>=calculated_values)
                  break;
              }
           }
         //---    ,      
         if(ArraySize(time)<available_bars || ArraySize(data)<calculated_values)
           {
            msg_last=msg_prepare_data;
            ShowCanvasMessage(msg_prepare_data);
            OC_prev_calculated=0;
            return(false);
           }
        }
     }
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|                      |
//+------------------------------------------------------------------+
bool CheckLoadedHistory()
  {
   bool loaded=false;
//---
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      //---    
      if(symbol_names[s]!=empty_symbol)
        {
         //---    
         if(OC_prev_calculated==0)
           {
            //---     /
            series_first_date[s]=(datetime)SeriesInfoInteger(symbol_names[s],Period(),SERIES_FIRSTDATE);
            //---      ( ), 
            if(series_first_date_last[s]==NULL)
               //---     /    
               //          
               series_first_date_last[s]=series_first_date[s];
           }
         else
           {
            //---     /
            series_first_date[s]=(datetime)SeriesInfoInteger(symbol_names[s],Period(),SERIES_FIRSTDATE);
            //---   ,       ,  ,   ,
            //           
            if(series_first_date_last[s]>series_first_date[s])
              {
               //---    
               Print("(",symbol_names[s],",",TimeframeToString(Period()),
                     ") >  /   : ",
                     series_first_date_last[s]," > ",series_first_date[s]);
               //---  
               series_first_date_last[s]=series_first_date[s];
               loaded=true;
              }
           }
        }
     }
//---   /   , 
//          
   if(loaded)
      return(false);
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|    /                |
//+------------------------------------------------------------------+
bool CheckSymbolIsSynchronized()
  {
//---     ,   
   if(TerminalInfoInteger(TERMINAL_CONNECTED))
     {
      for(int s=0; s<SYMBOLS_COUNT; s++)
        {
         //---   
         if(symbol_names[s]!=empty_symbol)
           {
            //---    ,      
            if(!SeriesInfoInteger(symbol_names[s],Period(),SERIES_SYNCHRONIZED))
              {
               msg_last=msg_not_synchronized;
               ShowCanvasMessage(msg_not_synchronized);
               return(false);
              }
           }
        }
     }
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
string TimeframeToString(ENUM_TIMEFRAMES timeframe)
  {
   string str="";
//---    ,    
   if(timeframe==WRONG_VALUE || timeframe== NULL)
      timeframe= Period();
   switch(timeframe)
     {
      case PERIOD_M1  : str="M1";  break;
      case PERIOD_M2  : str="M2";  break;
      case PERIOD_M3  : str="M3";  break;
      case PERIOD_M4  : str="M4";  break;
      case PERIOD_M5  : str="M5";  break;
      case PERIOD_M6  : str="M6";  break;
      case PERIOD_M10 : str="M10"; break;
      case PERIOD_M12 : str="M12"; break;
      case PERIOD_M15 : str="M15"; break;
      case PERIOD_M20 : str="M20"; break;
      case PERIOD_M30 : str="M30"; break;
      case PERIOD_H1  : str="H1";  break;
      case PERIOD_H2  : str="H2";  break;
      case PERIOD_H3  : str="H3";  break;
      case PERIOD_H4  : str="H4";  break;
      case PERIOD_H6  : str="H6";  break;
      case PERIOD_H8  : str="H8";  break;
      case PERIOD_H12 : str="H12"; break;
      case PERIOD_D1  : str="D1";  break;
      case PERIOD_W1  : str="W1";  break;
      case PERIOD_MN1 : str="MN1"; break;
     }
//---
   return(str);
  }
//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+
bool DetermineFirstTrueBar()
  {
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      datetime time[];           //   
      int      available_bars=0; //  
      //---    ,   
      if(symbol_names[s]==empty_symbol)
         continue;
      //---     
      available_bars=Bars(symbol_names[s],Period());
      //---    .   ,   .
      if(CopyTime(symbol_names[s],Period(),0,available_bars,time)<available_bars)
         return(false);
      //---     ,    
      limit_time[s]=GetFirstTrueBarTime(time);
      //---      
      CreateVerticalLine(0,0,limit_time[s],prefix+symbol_names[s]+": begin time series",
                         2,STYLE_SOLID,line_colors[s],false,TimeToString(limit_time[s]),"\n");
     }
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|                |
//+------------------------------------------------------------------+
datetime GetFirstTrueBarTime(datetime &time[])
  {
   datetime true_period =NULL; //    
   int      array_size  =0;    //  
//---   
   array_size=ArraySize(time);
   ArraySetAsSeries(time,false);
//---    
   for(int i=1; i<array_size; i++)
     {
      //---     
      if(time[i]-time[i-1]==PeriodSeconds())
        {
         //---    
         true_period=time[i];
         break;
        }
     }
//---     
   return(true_period);
  }
//+------------------------------------------------------------------+
//|                  |
//+------------------------------------------------------------------+
void CreateVerticalLine(long            chart_id,           // id 
                        int             window_number,      //  
                        datetime        time,               // 
                        string          object_name,        //  
                        int             line_width,         //  
                        ENUM_LINE_STYLE line_style,         //  
                        color           line_color,         //  
                        bool            selectable,         //   ,  FALSE
                        string          description_text,   //  
                        string          tooltip)            //   ,  "\n"
  {
//---    
   if(ObjectCreate(chart_id,object_name,OBJ_VLINE,window_number,time,0))
     {
      //---   
      ObjectSetInteger(chart_id,object_name,OBJPROP_TIME,time);
      ObjectSetInteger(chart_id,object_name,OBJPROP_SELECTABLE,selectable);
      ObjectSetInteger(chart_id,object_name,OBJPROP_STYLE,line_style);
      ObjectSetInteger(chart_id,object_name,OBJPROP_WIDTH,line_width);
      ObjectSetInteger(chart_id,object_name,OBJPROP_COLOR,line_color);
      ObjectSetString(chart_id,object_name,OBJPROP_TEXT,description_text);
      ObjectSetString(chart_id,object_name,OBJPROP_TOOLTIP,tooltip);
     }
  }
//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+
void CreateHorizontalLine(long            chart_id,      // id 
                          int             window_number, //  
                          string          object_name,   //  
                          double          price,         //  
                          int             line_width,    //  
                          ENUM_LINE_STYLE line_style,    //  
                          color           line_color,    //  
                          bool            selectable,    //   ,  FALSE
                          bool            selected,      //  
                          bool            back,          //  
                          string          tooltip)       //   ,  "\n"
  {
//---    
   if(ObjectCreate(chart_id,object_name,OBJ_HLINE,window_number,0,price))
     {
      //---   
      ObjectSetInteger(chart_id,object_name,OBJPROP_SELECTABLE,selectable);
      ObjectSetInteger(chart_id,object_name,OBJPROP_SELECTED,selected);
      ObjectSetInteger(chart_id,object_name,OBJPROP_BACK,back);
      ObjectSetInteger(chart_id,object_name,OBJPROP_STYLE,line_style);
      ObjectSetInteger(chart_id,object_name,OBJPROP_WIDTH,line_width);
      ObjectSetInteger(chart_id,object_name,OBJPROP_COLOR,line_color);
      ObjectSetString(chart_id,object_name,OBJPROP_TOOLTIP,tooltip);
     }
  }
//+------------------------------------------------------------------+
//|                               |
//+------------------------------------------------------------------+
void PrepareData(int bar_index,int symbol_number,datetime const &time[])
  {
   int attempts=100; //   
//---      
   datetime symbol_time[];
//---     
   double atr_values[];
//---      
   if(time[bar_index]>=limit_time[symbol_number])
     {
      //---  
      for(int i=0; i<attempts; i++)
        {
         if(CopyTime(symbol_names[symbol_number],0,time[bar_index],1,symbol_time)==1)
           {
            tmp_symbol_time[symbol_number].time[bar_index]=symbol_time[0];
            break;
           }
        }
      //---   
      for(int i=0; i<attempts; i++)
        {
         if(CopyBuffer(symbol_handles[symbol_number],0,time[bar_index],1,atr_values)==1)
           {
            tmp_atr_values[symbol_number].value[bar_index]=atr_values[0];
            break;
           }
        }
     }
//---      ,   
   else
      tmp_atr_values[symbol_number].value[bar_index]=EMPTY_VALUE;
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
void ProgressPercentage(int bar_index,int symbol_number,double &percent)
  {
   string message_text="";
   percent=(double(bar_index)/OC_rates_total)*100;
//---
   if(percent<=9.99)
      message_text="0"+DoubleToString(percent,0);
   else if(percent<99)
      message_text=DoubleToString(percent,0);
   else
      message_text="100";
//---
   msg_last=msg_sync_update="  ("+(string)OC_rates_total+" ) : "+
            symbol_names[symbol_number]+
            "("+(string)(symbol_number+1)+"/"+(string)SYMBOLS_COUNT+") - "+message_text+"% ... ";
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void FillIndicatorBuffers(int bar_index,int symbol_number,datetime const &time[])
  {
//---     
   bool check_value=false;
//---    
   static int bars_count=0;
//---         
   if(bar_index==0)
      bars_count=0;
//---      ,    
//      ,  
   if(bars_count<IndicatorPeriod && time[bar_index]>=limit_time[symbol_number])
      bars_count++;
//---    ,        
   if(bars_count>=IndicatorPeriod && 
      time[bar_index]==tmp_symbol_time[symbol_number].time[bar_index])
     {
      //---     
      if(tmp_atr_values[symbol_number].value[bar_index]!=EMPTY_VALUE)
        {
         check_value=true;
         atr_buffers[symbol_number].data[bar_index]=tmp_atr_values[symbol_number].value[bar_index];
        }
     }
//---   ,     
   if(!check_value)
      atr_buffers[symbol_number].data[bar_index]=EMPTY_VALUE;
  }
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
void SetIndicatorLevels()
  {
//---    
   subwindow_number=ChartWindowFind(0,subwindow_shortname);
//---  
   for(int i=0; i<LEVELS_COUNT; i++)
      CreateHorizontalLine(0,subwindow_number,
                           prefix+"level_0"+(string)(i+1)+"",
                           CorrectValueBySymbolDigits(indicator_levels[i]*_Point),
                           1,STYLE_DOT,clrLightSteelBlue,false,false,false,"\n");
  }
//+------------------------------------------------------------------+
//|        (double)          |
//+------------------------------------------------------------------+
double CorrectValueBySymbolDigits(double value)
  {
   return(_Digits==3 || _Digits==5) ? value*=10 : value;
  }
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
void DeleteLevels()
  {
   for(int i=0; i<LEVELS_COUNT; i++)
      DeleteObjectByName(prefix+"level_0"+(string)(i+1)+"");
  }
//+------------------------------------------------------------------+
//|                               |
//+------------------------------------------------------------------+
void DeleteVerticalLines()
  {
   for(int s=0; s<SYMBOLS_COUNT; s++)
      DeleteObjectByName(prefix+symbol_names[s]+": begin time series");
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
void DeleteObjectByName(string object_name)
  {
//---    
   if(ObjectFind(0,object_name)>=0)
     {
      //---     ,   
      if(!ObjectDelete(0,object_name))
         Print(" ("+IntegerToString(GetLastError())+")   !");
     }
  }
//+------------------------------------------------------------------+
